# coding: utf-8

"""
    SSPO Service

    The Scrum Software Process Ontology (SSPO) aims at establishing a common conceptualization on the Scrum domain, including roles, teams and projects.  # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class Sprint_(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'description': 'str',
        'start_date': 'datetime',
        'end_date': 'datetime',
        'application_reference': 'str',
        'scrum_process': 'str'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'description': 'description',
        'start_date': 'startDate',
        'end_date': 'endDate',
        'application_reference': 'application_reference',
        'scrum_process': 'scrum_process'
    }

    def __init__(self, id=None, name=None, description=None, start_date=None, end_date=None, application_reference=None, scrum_process=None):  # noqa: E501
        """Sprint_ - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._name = None
        self._description = None
        self._start_date = None
        self._end_date = None
        self._application_reference = None
        self._scrum_process = None
        self.discriminator = None

        if id is not None:
            self.id = id
        self.name = name
        if description is not None:
            self.description = description
        if start_date is not None:
            self.start_date = start_date
        if end_date is not None:
            self.end_date = end_date
        if application_reference is not None:
            self.application_reference = application_reference
        if scrum_process is not None:
            self.scrum_process = scrum_process

    @property
    def id(self):
        """Gets the id of this Sprint_.  # noqa: E501


        :return: The id of this Sprint_.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Sprint_.


        :param id: The id of this Sprint_.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this Sprint_.  # noqa: E501


        :return: The name of this Sprint_.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Sprint_.


        :param name: The name of this Sprint_.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if name is not None and len(name) > 200:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `200`")  # noqa: E501
        if name is not None and len(name) < 1:
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this Sprint_.  # noqa: E501


        :return: The description of this Sprint_.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Sprint_.


        :param description: The description of this Sprint_.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def start_date(self):
        """Gets the start_date of this Sprint_.  # noqa: E501


        :return: The start_date of this Sprint_.  # noqa: E501
        :rtype: datetime
        """
        return self._start_date

    @start_date.setter
    def start_date(self, start_date):
        """Sets the start_date of this Sprint_.


        :param start_date: The start_date of this Sprint_.  # noqa: E501
        :type: datetime
        """

        self._start_date = start_date

    @property
    def end_date(self):
        """Gets the end_date of this Sprint_.  # noqa: E501


        :return: The end_date of this Sprint_.  # noqa: E501
        :rtype: datetime
        """
        return self._end_date

    @end_date.setter
    def end_date(self, end_date):
        """Sets the end_date of this Sprint_.


        :param end_date: The end_date of this Sprint_.  # noqa: E501
        :type: datetime
        """

        self._end_date = end_date

    @property
    def application_reference(self):
        """Gets the application_reference of this Sprint_.  # noqa: E501


        :return: The application_reference of this Sprint_.  # noqa: E501
        :rtype: str
        """
        return self._application_reference

    @application_reference.setter
    def application_reference(self, application_reference):
        """Sets the application_reference of this Sprint_.


        :param application_reference: The application_reference of this Sprint_.  # noqa: E501
        :type: str
        """

        self._application_reference = application_reference

    @property
    def scrum_process(self):
        """Gets the scrum_process of this Sprint_.  # noqa: E501


        :return: The scrum_process of this Sprint_.  # noqa: E501
        :rtype: str
        """
        return self._scrum_process

    @scrum_process.setter
    def scrum_process(self, scrum_process):
        """Sets the scrum_process of this Sprint_.


        :param scrum_process: The scrum_process of this Sprint_.  # noqa: E501
        :type: str
        """

        self._scrum_process = scrum_process

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Sprint_, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Sprint_):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
